Package: inteq
Type: Package
Title: Numerical Solution of Integral Equations
Version: 1.1
Authors@R: c(person("Mark", "Clements", role = c("aut", "cre"),
		     email = "mark.clements@ki.se"),
	     person("Aaron", "Jehle", role="aut"),
	     person("Matthew", "Thomas", role="ctb", email="mthomas@ftc.gov"))
Description: An R implementation of Matthew Thomas's 'Python' library 'inteq'. First, this solves Fredholm integral equations of the first kind ($f(s) = \int_a^b K(s, y) g(y) dy$) using methods described by Twomey (1963) <doi:10.1145/321150.321157>. Second, this solves Volterra integral equations of the first kind ($f(s) = \int_0^s K(s,y) g(t) dt$) using methods from Betto and Thomas (2021) <doi:10.48550/arXiv.2106.08496>. Third, this solves Voltera integral equations of the second kind ($g(s) = f(s) + \int_a^s K(s,y) g(y) dy$) using methods from Linz (1969) <doi:10.1137/0706034>.
Suggests: knitr, rmarkdown, testthat
VignetteBuilder: knitr
License: MIT + file LICENSE
RoxygenNote: 7.3.2
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2026-04-25 13:40:04 UTC; marcle
Author: Mark Clements [aut, cre],
  Aaron Jehle [aut],
  Matthew Thomas [ctb]
Maintainer: Mark Clements <mark.clements@ki.se>
Repository: CRAN
Date/Publication: 2026-04-25 14:00:02 UTC
Built: R 4.5.2; ; 2026-04-26 23:54:39 UTC; unix

# Solve Volterra and Fredholm integral equations

![plot generated by package](https://raw.githubusercontent.com/mwt/inteq/main/assets/volterra-example.svg)

This package estimates Volterra and Fredholm integral equations.

## Volterra

This package provides the function `SolveVolterra` which approximates the solution, g(x), to the Volterra Integral Equation of the first kind:

![f(s) = \int_0^s K(s,y) g(y) dy](https://raw.githubusercontent.com/mwt/inteq/main/assets/volterra-equation.svg)

using the method in [Betto and Thomas (2021)](https://mattwthomas.com/papers/asymmetric-all-pay-contests-with-spillovers/).

### Parameters

```
k : function
    The kernel function that takes two arguments.
f : function
    The left hand side (free) function that takes one argument.
b : float
    Upper bound of the estimate, defaults to 1.
num : int
    Number of estimation points between zero and `b`.
```

### Returns

```
grid : 2-D array
    Input values are in the first row and output values are in the second row.
```

## Fredholm

This package provides the function `SolveFredholm` which approximates the solution, g(x), to the Fredholm Integral Equation of the first kind:

![f(s) = \int_0^b K(s,y) g(y) dy](https://raw.githubusercontent.com/mwt/inteq/main/assets/fredholm-equation.svg)

using the method described in [Twomey (1963)](https://doi.org/10.1145/321150.321157). It will return a smooth curve that is an approximate solution. However, it may not be a good approximate to the true solution.

### Parameters

```
k : function
    The kernel function that takes two arguments.
f : function 
    The left hand side (free) function that takes one argument.
a : float
    Lower bound of the of the Fredholm definite integral, defaults to -1.
b : float
    Upper bound of the of the Fredholm definite integral, defaults to 1.
num : int
    Number of estimation points between zero and `b`.
```

### Returns

```
grid : 2-D array
    Input values are in the first row and output values are in the second row.
```

## ----echo=TRUE----------------------------------------------------------------

library(inteq)

# Define the kernel function
k <- function(s, t) {
    ifelse(abs(s - t) <= 3, 1 + cos(pi * (t - s) / 3), 0)
}

# Define the right-hand side function
f <- function(s) {
    sp <- abs(s)
    sp3 <- sp * pi / 3
    ((6 - sp) * (2 + cos(sp3)) + (9 / pi) * sin(sp3)) / 2
}

# Define the true solution for comparison
trueg <- function(s) {
    k(0, s)
}

# Solve the Fredholm equation
res <- fredholm_solve(
    k, f, -3, 3, 1001L,
    smin = -6, smax = 6, snum = 2001L,
    gamma = 0.01
)

# Plot the results on the same graph using base graphics
plot(
    res$ygrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(-3, 3),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Fredholm Equation Solution"
)
# add the true solution
lines(res$ygrid, trueg(res$ygrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)

#end of code chunk

## ----echo=TRUE----------------------------------------------------------------
k <- function(s,t) {
        cos(t-s)
}
trueg <- function(s) {
    (2+s**2)/2
}

res <- volterra_solve(k,a=0,b=1,num=1000)

plot(
    res$sgrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(0, 1),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Volterra Equation Solution first kind"
)
# add the true solution
lines(res$sgrid, trueg(res$sgrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)


## ----echo=TRUE----------------------------------------------------------------
k <- function(s,t) {
        0.5 * (t-s)** 2 * exp(t-s)
}
free <- function(t) {
    0.5 * t**2 * exp(-t)
}
true <- function(t) {
    1/3 * (1 - exp(-3*t/2) * (cos(sqrt(3)/2*t) + sqrt(3) * sin(sqrt(3)/2*t)))
}

res <- volterra_solve2(k,free,a=0,b=6,num=100)

plot(
    res$sgrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(0, 6),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Volterra Equation Solution second kind"
)
# add the true solution
lines(res$sgrid, true(res$sgrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)

#' Solve a Fredholm equation of the first and second kind
#' @param k kernel function of two time scales
#' @param f left hand side function with f(a)=0
#' @param a lower bound of the grid for the integral approximation 
#' @param b upper bound of the grid for the integral approximation 
#' @param num number of points for the grid of the integral approximation 
#' @param smin lower bound of enforcement values for equation
#' @param smax upper bound of enforcement values for equation
#' @param snum number of points for the grid for the equation
#' @param gamma regularization parameter
#' @return data-frame with evaluation points 'ygrid' and calculations 'ggrid'
#' @examples
#' # Define the kernel function
#' k <- function(s, t) {
#'     ifelse(abs(s - t) <= 3, 1 + cos(pi * (t - s) / 3), 0)
#' }
#' 
#' # Define the right-hand side function
#' f <- function(s) {
#'     sp <- abs(s)
#'     sp3 <- sp * pi / 3
#'     ((6 - sp) * (2 + cos(sp3)) + (9 / pi) * sin(sp3)) / 2
#' }
#' 
#' # Define the true solution for comparison
#' trueg <- function(s) {
#'     k(0, s)
#' }
#' 
#' # Solve the Fredholm equation
#' res <- fredholm_solve(
#'     k, f, -3, 3, 1001L,
#'     smin = -6, smax = 6, snum = 2001L,
#'     gamma = 0.01
#' )
#' 
#' # Plot the results on the same graph using base graphics
#' plot(
#'     res$ygrid, res$ggrid,
#'     type = "l",
#'     col = "blue",
#'     xlim = c(-3, 3),
#'     #ylim = c(-1, 1),
#'     xlab = "s",
#'     ylab = "g(s)",
#'     main = "Fredholm Equation Solution"
#' )
#' # add the true solution
#' lines(res$ygrid, trueg(res$ygrid), col = "red", lty = 2)
#' legend( 
#'     "topright",
#'     legend = c("Estimated Value", "True Value"),
#'     col = c("blue", "red"),
#'     lty = c(1, 2)
#' )
#' @export
fredholm_solve =
    function(k, f = function(x) x, a = -0, b = 1, num = 41L, smin = 0, smax = 1, snum = 41L, gamma = 0.001) {

        #num needs to be odd to apply simpson's rule
        if (num %% 2 == 0) {
            warning("num should be odd for Simpson's rule, proceding with num +1")
            num = num + 1L
        }

        # grid for enforcement points
        sgrid = seq(smin,smax,length.out=snum+1)[-1]
        # grid for integration points
        ygrid = seq(a,b,length.out=num+1)[-1]

        weights = simpson(num)

        # quadrature matrix
        ksqur = outer(sgrid, ygrid, "k") %*% diag(weights)

        if(gamma != 0) {
            Hmat = makeH(num)
            AAgH = t(ksqur) %*% ksqur + gamma * Hmat
        } else {
            AAgH = t(ksqur) %*% ksqur
        }

        ggrid = solve(AAgH, t(ksqur) %*% f(sgrid))
        data.frame(ygrid, ggrid = ggrid * num / (b-a))
}

#' Solve a Volterra equation of the first kind
#' @param k kernel function of two time scales
#' @param f left hand side (free) function with f(a)=0
#' @param a lower bound of the integral
#' @param b upper bound of the integral
#' @param num integer for the number of evaluation points
#' @param method string for the method
#' @return data-frame with evaluation points 'sgrid' and calculations 'ggrid'
#' @examples
#' k <- function(s,t) {
#'         cos(t-s)
#' }
#' trueg <- function(s) {
#'     (2+s**2)/2
#' }
#' 
#' res <- volterra_solve(k,a=0,b=1,num=1000)
#' 
#' plot(
#'     res$sgrid, res$ggrid,
#'     type = "l",
#'     col = "blue",
#'     xlim = c(0, 1),
#'     #ylim = c(-1, 1),
#'     xlab = "s",
#'     ylab = "g(s)",
#'     main = "Volterra Equation Solution first kind"
#' )
#' # add the true solution
#' lines(res$sgrid, trueg(res$sgrid), col = "red", lty = 2)
#' legend( 
#'     "topright",
#'     legend = c("Estimated Value", "True Value"),
#'     col = c("blue", "red"),
#'     lty = c(1, 2)
#' )
#' @export
volterra_solve =
    function(k, f = function(x) x, a = 0, b = 1, num = 1000L,
             method=c("midpoint","trapezoid")) {
        method = match.arg(method)
        sgrid = seq(a,b,length.out=num+1)[-1]
        ktril = outer(sgrid,sgrid,"k")
        ktril[upper.tri(ktril)] = 0
        if (method=="trapezoid") {
            diag(ktril) = diag(ktril)/2
            ktril[,1] = ktril[,1] + k(sgrid,0)/2 # should the zero be 'a'?
        }
        ggrid = solve(ktril, f(sgrid))
        data.frame(sgrid, ggrid = ggrid * num / (b-a))
}

## a = 0; b = 1; num=10L
## k = function(x,y) x+y
## sgrid = seq(a,b,length.out=num+1)[-1]
## ktril = outer(sgrid, sgrid, k)
## volterra_solve(k,num=10L)

#' Solve a Volterra equation of the second kind
#' @param k kernel function of two time scales
#' @param f left hand side (free) function with f(a)=0
#' @param a lower bound of the integral
#' @param b upper bound of the integral
#' @param num integer for the number of evaluation points
#' @param method string for the method
#' @return data-frame with evaluation points 'sgrid' and calculated values 'ggrid' 
#' @examples
#' k <- function(s,t) {
#'         0.5 * (t-s)** 2 * exp(t-s)
#' }
#' free <- function(t) {
#'     0.5 * t**2 * exp(-t)
#' }
#' true <- function(t) {
#'     1/3 * (1 - exp(-3*t/2) * (cos(sqrt(3)/2*t) + sqrt(3) * sin(sqrt(3)/2*t)))
#' }
#' 
#' res <- volterra_solve2(k,free,a=0,b=6,num=100)
#' 
#' plot(
#'     res$sgrid, res$ggrid,
#'     type = "l",
#'     col = "blue",
#'     xlim = c(0, 6),
#'     #ylim = c(-1, 1),
#'     xlab = "s",
#'     ylab = "g(s)",
#'     main = "Volterra Equation Solution second kind"
#' )
#' # add the true solution
#' lines(res$sgrid, true(res$sgrid), col = "red", lty = 2)
#' legend( 
#'     "topright",
#'     legend = c("Estimated Value", "True Value"),
#'     col = c("blue", "red"),
#'     lty = c(1, 2)
#' )
#' 
#' @export
volterra_solve2 =
    function(k, f = function(x) x,
             a = 0, b = 1, num = 1001L,
             method=c("trapezoid","midpoint")) {
        method = match.arg(method)
        sgrid = seq(a,b,length.out=num)
        h = (b-a)/(num-1L)
        ktril = outer(sgrid,sgrid,k)
        ktril[upper.tri(ktril)] = 0
        if (method=="trapezoid") {
            ktril[,1] = ktril[,1]/2
            diag(ktril) = diag(ktril)/2
        }
        ktril[1,1] = 0
        ggrid = solve(diag(num) - h*ktril, f(sgrid))
        data.frame(sgrid, ggrid)
}

#' Internal function to convert (row,col) to vector index
#' @param row integer vector the rows
#' @param col integer vector for the columns
#' @param nrows integer for the number of rows
#' @returns an index vector for the cells
indexing = function(row,col,nrows) {
    (col-1)*nrows+row
}

#' Internal function to generate diagonal matrices with possibly an offset with possibly mirrored diagonal
#' @param x vector
#' @param index integer offset index for the diagonal (can be negative)
#' @param mirror logical for whether to mirror at the diagonal
#' @returns diagonal matrix
diag_ext = function(x, index, mirror=FALSE) {
    stopifnot(is.integer(index))
    if (index==0L) return(diag(x)) # ignores mirror
    if (mirror) return(diag_ext(x,index) + diag_ext(x,-index))
    if (index<0L) return(t(diag_ext(x,-index)))
    n = length(x)
    dim = n+index
    diag = matrix(0, dim, dim)
    diag[indexing(1:n,(1:n)+index,dim)] = x
    ## for (i in 1:n)
    ##     diag[i,i+index-1L] = x[i]
    diag
}

#' Make H Matrix as in (Twomey 1963)
#' @param dim integer for the number of dimensions of H (i.e. number of nodes for integral approximation)
#' @returns a matrix
makeH = function(dim) {
    d2 = rep(1, dim-2L)
    d1 = c(-2, rep(-4, dim-3), -2)
    d0 = c(1,5,rep(6,dim-4),5,1)
    diag_ext(d1,1L,TRUE) + diag_ext(d2,2L,TRUE) + diag(d0)
}

#' Internal function to calculate integration weights for Simpson's rule
#' @param dim integer for the number of nodes
#' @returns a double vector for the integration weights
simpson = function(dim) {
    stopifnot(dim>2, dim %% 2 == 1)
    tiles = rep(c(4,2),dim %/% 2)
    c(1,tiles[1:(dim-2)],1)/3
}

#' Internal function to smooth a vector of values using two-point average
#' @param v double vector to be smoother
#' @returns smoothed double vector
smooth = function(v) {
    dim = length(v)
    smat = diag(c(1,rep(0.5, dim-1L))) + diag_ext(rep(0.5, dim-1),-1L)
    smat %*% v
}

library(inteq)

expect_eps <- function(expr, value, eps=1e-7)
    expect_lt(max(abs(expr-value)),eps)

context("helpers")
##
test_that("indexing", {
    expect_true(all(indexing(1:3, 1:3, 4) == c(1,6,11)))
})
test_that("diag_ext", {
    expect_true(all(diag_ext(1:3,1L,TRUE) ==
                    c(0,1,0,0,
                      1,0,2,0,
                      0,2,0,3,
                      0,0,3,0)))
})
test_that("makeH", {
    expect_true(all(makeH(5) ==
                    c(1,-2,1,0,0,
                      -2,5,-4,1,0,
                      1,-4,6,-4,1,
                      0,1,-4,5,-2,
                      0,0,1,-2,1)))
})
test_that("simpson", {
    expect_true(all(simpson(7L) == c(1,4,2,4,2,4,1)/3))
})
test_that("smooth", {
    expect_true(all(smooth(1:5) == c(1,1.5,2.5,3.5,4.5)))
})


context("fredholm")
##
test_that("fredholm_solve", {
    k <- function(s, t) {
    ifelse(abs(s-t)<=3,1 + cos(pi*(t-s)/3), 0)
    }
    f <- function(s) {
    sp <- abs(s)
    sp3 <- sp * pi / 3
    ((6 - sp) * (2 + cos(sp3)) + (9 / pi) * sin(sp3)) / 2
    }
    trueg <- function(s) {
        k(0,s)
    }
    res = fredholm_solve(k,f,-3,3,1001L,smin=-6,smax=6,snum=2001L,gamma=0.01)
    expect_true(sum((res$ggrid - sapply(res$ygrid,trueg))**2) < 1e-6)
})

context("volterra")
##
test_that("volterra_solve", {
    k <- function(s,t) {
        cos(t-s)
    }
    trueg <- function(s) {
        (2+s**2)/2
    }
        
    expect_true(sum((volterra_solve(k,a=0,b=1,num=1000)$ggrid - trueg(seq(0,1,length.out=1000)))**2) < 1e-3
    )
})

test_that("volterra_solve2", {
        k <- function(s,t) {
        0.5 * (t-s)** 2 * exp(t-s)
    }
    free <- function(t) {
        0.5 * t**2 * exp(-t)
    }
    true <- function(t) {
        1/3 * (1 - exp(-3*t/2) * (cos(sqrt(3)/2*t) + sqrt(3) * sin(sqrt(3)/2*t)))
    }
    expect_true(sum((volterra_solve2(k,free,a=0,b=6,num=100)$ggrid - true(seq(0,6,length.out=100)))**2) < 1e-11)
})

---
title: "Inteq R documentation"
authors:
  - name: Aaron Jehle
    orcid: 0000-0002-3809-8248
    affiliation: 1
  - name: Mark Clements
    affiliation: 1
  - name: Matthew W. Thomas
    affiliation: 2
affiliations:
 - name: Department of Medical Epidemiology and Biostatistics, Karolinska Institutet, Stockholm, Sweden
   index: 1
 - name: Bureau of Economics, Federal Trade Commission, Washington, DC, USA
   index: 2
date: "`r Sys.Date()`"
output:
  rmarkdown::html_document:
    toc: true
    toc_depth: 2
    toc_float: true
    theme: lumen
    keep_md: true
vignette: >
  %\VignetteIndexEntry{Inteq R documentation}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}

---

This R package estimates Volterra and Fredholm integral equations.
It is a translation into R of the Python package "inteq" by Matthew W. Thomas (https://github.com/mwt/inteq).

Installation:
//to be completed

## Supported equations

# Fredholm integral equations


This package provides the function fredholm_solve which approximates the solution, $g(x)$, to the Fredholm Integral Equation of the first kind:

\begin{align}
f(s) = \int_a^b K(s, y)\, g(y)\, dy,
\end{align}

using the method described in Twomey (1963). It will return a grid that is an approximate solution, as demonstrated by the following example:

\[
f(s) = \int_{-3}^{3} K(s, y)\, g(y)\, dy,
\]

where the kernel \( K(s, y) \) and left-hand side \( f(s) \) are defined as:

\[
K(s, y) = 
\begin{cases}
1 + \cos\left(\dfrac{\pi (y - s)}{3}\right), & \text{if } |s - y| \leq 3 \\
0, & \text{otherwise}
\end{cases},
\]

\[
f(s) = \frac{1}{2} \left[ (6 - |s|)\left(2 + \cos\left(\frac{|s| \pi}{3}\right)\right) + \frac{9}{\pi} \sin\left(\frac{|s| \pi}{3}\right) \right].
\]

The true solution is \( g(y) = K(0, y) \).

```{r, echo=TRUE}

library(inteq)

# Define the kernel function
k <- function(s, t) {
    ifelse(abs(s - t) <= 3, 1 + cos(pi * (t - s) / 3), 0)
}

# Define the right-hand side function
f <- function(s) {
    sp <- abs(s)
    sp3 <- sp * pi / 3
    ((6 - sp) * (2 + cos(sp3)) + (9 / pi) * sin(sp3)) / 2
}

# Define the true solution for comparison
trueg <- function(s) {
    k(0, s)
}

# Solve the Fredholm equation
res <- fredholm_solve(
    k, f, -3, 3, 1001L,
    smin = -6, smax = 6, snum = 2001L,
    gamma = 0.01
)

# Plot the results on the same graph using base graphics
plot(
    res$ygrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(-3, 3),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Fredholm Equation Solution"
)
# add the true solution
lines(res$ygrid, trueg(res$ygrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)

#end of code chunk
```

# Volterra integral equations

This package provides the function volterra_solve which approximates the solution, g(x), to the Volterra Integral Equation of the first kind:

\begin{align}
f(s) = \int_a^s K(s,y) g(y) dy,
\end{align}

using the method in Betto and Thomas (2021), as demonstrated by the following example:

\[
f(s) = \int_0^s \cos(t-s) g(t) dt,
\]

with left-hand side

\[
f(s) = \int_0^s \cos(t-s) \frac{2 + t^2}{2} dt
\]

and true solution

\[
g(s) = \frac{2 + s^2}{2}.
\]


```{r, echo=TRUE}
k <- function(s,t) {
        cos(t-s)
}
trueg <- function(s) {
    (2+s**2)/2
}

res <- volterra_solve(k,a=0,b=1,num=1000)

plot(
    res$sgrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(0, 1),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Volterra Equation Solution first kind"
)
# add the true solution
lines(res$sgrid, trueg(res$sgrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)

```

It also provides volterra_solve2 which approximates the solution, g(x), to the Volterra Integral Equation of the second kind:

\begin{align}
g(s) = f(s) + \int_a^s K(s,y) g(y) dy,
\end{align}

using the method in Linz (1969), as demonstrated by the following example:

\[
g(s) = 1 + \int_0^s (s-t) g(t) dt,
\]

with true solution

\[
g(s) = \cosh(s).
\]

```{r, echo=TRUE}
k <- function(s,t) {
        0.5 * (t-s)** 2 * exp(t-s)
}
free <- function(t) {
    0.5 * t**2 * exp(-t)
}
true <- function(t) {
    1/3 * (1 - exp(-3*t/2) * (cos(sqrt(3)/2*t) + sqrt(3) * sin(sqrt(3)/2*t)))
}

res <- volterra_solve2(k,free,a=0,b=6,num=100)

plot(
    res$sgrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(0, 6),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Volterra Equation Solution second kind"
)
# add the true solution
lines(res$sgrid, true(res$sgrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)

```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/volterra.R
\name{volterra_solve2}
\alias{volterra_solve2}
\title{Solve a Volterra equation of the second kind}
\usage{
volterra_solve2(
  k,
  f = function(x) x,
  a = 0,
  b = 1,
  num = 1001L,
  method = c("trapezoid", "midpoint")
)
}
\arguments{
\item{k}{kernel function of two time scales}

\item{f}{left hand side (free) function with f(a)=0}

\item{a}{lower bound of the integral}

\item{b}{upper bound of the integral}

\item{num}{integer for the number of evaluation points}

\item{method}{string for the method}
}
\value{
data-frame with evaluation points 'sgrid' and calculated values 'ggrid'
}
\description{
Solve a Volterra equation of the second kind
}
\examples{
k <- function(s,t) {
        0.5 * (t-s)** 2 * exp(t-s)
}
free <- function(t) {
    0.5 * t**2 * exp(-t)
}
true <- function(t) {
    1/3 * (1 - exp(-3*t/2) * (cos(sqrt(3)/2*t) + sqrt(3) * sin(sqrt(3)/2*t)))
}

res <- volterra_solve2(k,free,a=0,b=6,num=100)

plot(
    res$sgrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(0, 6),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Volterra Equation Solution second kind"
)
# add the true solution
lines(res$sgrid, true(res$sgrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{simpson}
\alias{simpson}
\title{Internal function to calculate integration weights for Simpson's rule}
\usage{
simpson(dim)
}
\arguments{
\item{dim}{integer for the number of nodes}
}
\value{
a double vector for the integration weights
}
\description{
Internal function to calculate integration weights for Simpson's rule
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/volterra.R
\name{volterra_solve}
\alias{volterra_solve}
\title{Solve a Volterra equation of the first kind}
\usage{
volterra_solve(
  k,
  f = function(x) x,
  a = 0,
  b = 1,
  num = 1000L,
  method = c("midpoint", "trapezoid")
)
}
\arguments{
\item{k}{kernel function of two time scales}

\item{f}{left hand side (free) function with f(a)=0}

\item{a}{lower bound of the integral}

\item{b}{upper bound of the integral}

\item{num}{integer for the number of evaluation points}

\item{method}{string for the method}
}
\value{
data-frame with evaluation points 'sgrid' and calculations 'ggrid'
}
\description{
Solve a Volterra equation of the first kind
}
\examples{
k <- function(s,t) {
        cos(t-s)
}
trueg <- function(s) {
    (2+s**2)/2
}

res <- volterra_solve(k,a=0,b=1,num=1000)

plot(
    res$sgrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(0, 1),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Volterra Equation Solution first kind"
)
# add the true solution
lines(res$sgrid, trueg(res$sgrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{smooth}
\alias{smooth}
\title{Internal function to smooth a vector of values using two-point average}
\usage{
smooth(v)
}
\arguments{
\item{v}{double vector to be smoother}
}
\value{
smoothed double vector
}
\description{
Internal function to smooth a vector of values using two-point average
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{diag_ext}
\alias{diag_ext}
\title{Internal function to generate diagonal matrices with possibly an offset with possibly mirrored diagonal}
\usage{
diag_ext(x, index, mirror = FALSE)
}
\arguments{
\item{x}{vector}

\item{index}{integer offset index for the diagonal (can be negative)}

\item{mirror}{logical for whether to mirror at the diagonal}
}
\value{
diagonal matrix
}
\description{
Internal function to generate diagonal matrices with possibly an offset with possibly mirrored diagonal
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fredholm.R
\name{fredholm_solve}
\alias{fredholm_solve}
\title{Solve a Fredholm equation of the first and second kind}
\usage{
fredholm_solve(
  k,
  f = function(x) x,
  a = -0,
  b = 1,
  num = 41L,
  smin = 0,
  smax = 1,
  snum = 41L,
  gamma = 0.001
)
}
\arguments{
\item{k}{kernel function of two time scales}

\item{f}{left hand side function with f(a)=0}

\item{a}{lower bound of the grid for the integral approximation}

\item{b}{upper bound of the grid for the integral approximation}

\item{num}{number of points for the grid of the integral approximation}

\item{smin}{lower bound of enforcement values for equation}

\item{smax}{upper bound of enforcement values for equation}

\item{snum}{number of points for the grid for the equation}

\item{gamma}{regularization parameter}
}
\value{
data-frame with evaluation points 'ygrid' and calculations 'ggrid'
}
\description{
Solve a Fredholm equation of the first and second kind
}
\examples{
# Define the kernel function
k <- function(s, t) {
    ifelse(abs(s - t) <= 3, 1 + cos(pi * (t - s) / 3), 0)
}

# Define the right-hand side function
f <- function(s) {
    sp <- abs(s)
    sp3 <- sp * pi / 3
    ((6 - sp) * (2 + cos(sp3)) + (9 / pi) * sin(sp3)) / 2
}

# Define the true solution for comparison
trueg <- function(s) {
    k(0, s)
}

# Solve the Fredholm equation
res <- fredholm_solve(
    k, f, -3, 3, 1001L,
    smin = -6, smax = 6, snum = 2001L,
    gamma = 0.01
)

# Plot the results on the same graph using base graphics
plot(
    res$ygrid, res$ggrid,
    type = "l",
    col = "blue",
    xlim = c(-3, 3),
    #ylim = c(-1, 1),
    xlab = "s",
    ylab = "g(s)",
    main = "Fredholm Equation Solution"
)
# add the true solution
lines(res$ygrid, trueg(res$ygrid), col = "red", lty = 2)
legend( 
    "topright",
    legend = c("Estimated Value", "True Value"),
    col = c("blue", "red"),
    lty = c(1, 2)
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{makeH}
\alias{makeH}
\title{Make H Matrix as in (Twomey 1963)}
\usage{
makeH(dim)
}
\arguments{
\item{dim}{integer for the number of dimensions of H (i.e. number of nodes for integral approximation)}
}
\value{
a matrix
}
\description{
Make H Matrix as in (Twomey 1963)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{indexing}
\alias{indexing}
\title{Internal function to convert (row,col) to vector index}
\usage{
indexing(row, col, nrows)
}
\arguments{
\item{row}{integer vector the rows}

\item{col}{integer vector for the columns}

\item{nrows}{integer for the number of rows}
}
\value{
an index vector for the cells
}
\description{
Internal function to convert (row,col) to vector index
}
